glibmm: Gio::Cancellable Class Reference

glibmm 2.66.9

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::Cancellable Class Reference

Allows actions to be cancelled. More...

`#include <giomm/cancellable.h>`

Inheritance diagram for Gio::Cancellable:
[legend]

## Public Types
using | SlotCancelledCallback = sigc::slot<void>
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| Cancellable (Cancellable && src) noexcept
Cancellable & | operator= (Cancellable && src) noexcept
| ~Cancellable () noexcept override
GCancellable * | gobj ()
| Provides access to the underlying C GObject.
const GCancellable * | gobj () const
| Provides access to the underlying C GObject.
GCancellable * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | is_cancelled () const
| Checks if a cancellable job has been cancelled.
int | get_fd () const
| Gets the file descriptor for a cancellable job.
bool | make_pollfd (GPollFD * pollfd)
| Creates a PollFD corresponding to cancellable; this can be passed to Glib::poll() and used to poll for cancellation.
void | release_fd ()
| Releases a resources previously allocated by g_cancellable_get_fd() or g_cancellable_make_pollfd().
void | cancel ()
| Will set cancellable to cancelled, and will emit the Cancellable::signal_cancelled() signal.
void | push_current ()
| Pushes cancellable onto the cancellable stack.
void | pop_current ()
| Pops cancellable off the cancellable stack (verifying that cancellable is on the top of the stack).
void | reset ()
| Resets cancellable to its uncancelled state.
gulong | connect (const SlotCancelledCallback & slot)
| Convenience function to connect to the Cancellable::signal_cancelled() signal.
void | disconnect (gulong handler_id)
| Disconnects a handler from a cancellable instance similar to Glib::signal_handler_disconnect().
Glib::SignalProxy< void > | signal_cancelled ()
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void * data)
void | set_data (const Quark & key, void * data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
void | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< Cancellable > | create ()
static Glib::RefPtr< Cancellable > | get_current ()
| Gets the top cancellable from the stack.

## Protected Member Functions
| Cancellable ()
virtual void | on_cancelled ()
| This is a default handler for the signal signal_cancelled().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::Cancellable > | wrap (GCancellable * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)

## Detailed Description

Allows actions to be cancelled.

Cancellable is a thread-safe operation cancellation stack used throughout GIO to allow for cancellation of synchronous and asynchronous operations.

Since glibmm 2.16

## Member Typedef Documentation

## ◆ SlotCancelledCallback

using Gio::Cancellable::SlotCancelledCallback = sigc::slot<void>

## Constructor & Destructor Documentation

## ◆ Cancellable() [1/2]

Gio::Cancellable::Cancellable | ( | Cancellable && | src | ) |
| noexcept

## ◆ ~Cancellable()

Gio::Cancellable::~Cancellable | ( |  | ) |
| overridenoexcept

## ◆ Cancellable() [2/2]

Gio::Cancellable::Cancellable | ( |  | ) |
| protected

## Member Function Documentation

## ◆ cancel()

void Gio::Cancellable::cancel | ( |  | ) |

Will set cancellable to cancelled, and will emit the Cancellable::signal_cancelled() signal.

(However, see the warning about race conditions in the documentation for that signal if you are planning to connect to it.)

This function is thread-safe. In other words, you can safely call it from a thread other than the one running the operation that was passed the cancellable.

If cancellable is nullptr, this function returns immediately for convenience.

The convention within GIO is that cancelling an asynchronous operation causes it to complete asynchronously. That is, if you cancel the operation from the same thread in which it is running, then the operation's SlotAsyncReady will not be invoked until the application returns to the main loop.

## ◆ connect()

gulong Gio::Cancellable::connect | ( | const SlotCancelledCallback & | slot | ) |

Convenience function to connect to the Cancellable::signal_cancelled() signal.

Also handles the race condition that may happen if the cancellable is cancelled right before connecting.

slot is called at most once, either directly at the time of the connect if cancellable is already cancelled, or when cancellable is cancelled in some thread.

See Cancellable::signal_cancelled() for details on how to use this.

Since glibmm 2.22

Parameters

  Slots | The slot to connect.

Returns
  The id of the signal handler or 0 if cancellable has already been cancelled.

## ◆ create()

Glib::RefPtr< Cancellable > Gio::Cancellable::create | ( |  | ) |
| static

## ◆ disconnect()

void Gio::Cancellable::disconnect | ( | gulong | handler_id | ) |

Disconnects a handler from a cancellable instance similar to Glib::signal_handler_disconnect().

Additionally, in the event that a signal handler is currently running, this call will block until the handler has finished. Calling this function from a Cancellable::signal_cancelled() signal handler will therefore result in a deadlock.

This avoids a race condition where a thread cancels at the same time as the cancellable operation is finished and the signal handler is removed. See Cancellable::signal_cancelled() for details on how to use this.

If cancellable is nullptr or handler_id is 0 this function does nothing.

Since glibmm 2.22

Parameters

  handler_id | Handler id of the handler to be disconnected, or 0.

## ◆ get_current()

Glib::RefPtr< Cancellable > Gio::Cancellable::get_current | ( |  | ) |
| static

Gets the top cancellable from the stack.

Returns
  A Cancellable from the top of the stack, or nullptr if the stack is empty.

## ◆ get_fd()

int Gio::Cancellable::get_fd | ( |  | ) | const

Gets the file descriptor for a cancellable job.

This can be used to implement cancellable operations on Unix systems. The returned fd will turn readable when cancellable is cancelled.

You are not supposed to read from the fd yourself, just check for readable status. Reading to unset the readable status is done with g_cancellable_reset().

After a successful return from this function, you should use g_cancellable_release_fd() to free up resources allocated for the returned file descriptor.

See also g_cancellable_make_pollfd().

Returns
  A valid file descriptor. -1 if the file descriptor is not supported, or on errors.

## ◆ get_type()

GType Gio::Cancellable::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GCancellable * Gio::Cancellable::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GCancellable * Gio::Cancellable::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GCancellable * Gio::Cancellable::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ is_cancelled()

bool Gio::Cancellable::is_cancelled | ( |  | ) | const

Checks if a cancellable job has been cancelled.

Returns
  true if cancellable is cancelled, false if called with nullptr or if item is not cancelled.

## ◆ make_pollfd()

bool Gio::Cancellable::make_pollfd | ( | GPollFD * | pollfd | ) |

Creates a PollFD corresponding to cancellable; this can be passed to Glib::poll() and used to poll for cancellation.

This is useful both for unix systems without a native poll and for portability to windows.

When this function returns true, you should use g_cancellable_release_fd() to free up resources allocated for the pollfd. After a false return, do not call g_cancellable_release_fd().

If this function returns false, either no cancellable was given or resource limits prevent this function from allocating the necessary structures for polling. (On Linux, you will likely have reached the maximum number of file descriptors.) The suggested way to handle these cases is to ignore the cancellable.

You are not supposed to read from the fd yourself, just check for readable status. Reading to unset the readable status is done with g_cancellable_reset().

Since glibmm 2.22

Parameters

  pollfd | A pointer to a PollFD.

Returns
  true if pollfd was successfully initialized, false on failure to prepare the cancellable.

## ◆ on_cancelled()

virtual void Gio::Cancellable::on_cancelled | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_cancelled().

## ◆ operator=()

Cancellable & Gio::Cancellable::operator= | ( | Cancellable && | src | ) |
| noexcept

## ◆ pop_current()

void Gio::Cancellable::pop_current | ( |  | ) |

Pops cancellable off the cancellable stack (verifying that cancellable is on the top of the stack).

## ◆ push_current()

void Gio::Cancellable::push_current | ( |  | ) |

Pushes cancellable onto the cancellable stack.

The current cancellable can then be received using g_cancellable_get_current().

This is useful when implementing cancellable operations in code that does not allow you to pass down the cancellable object.

This is typically called automatically by e.g. File operations, so you rarely have to call this yourself.

## ◆ release_fd()

void Gio::Cancellable::release_fd | ( |  | ) |

Releases a resources previously allocated by g_cancellable_get_fd() or g_cancellable_make_pollfd().

For compatibility reasons with older releases, calling this function is not strictly required, the resources will be automatically freed when the cancellable is finalized. However, the cancellable will block scarce file descriptors until it is finalized if this function is not called. This can cause the application to run out of file descriptors when many Cancellables are used at the same time.

Since glibmm 2.22

## ◆ reset()

void Gio::Cancellable::reset | ( |  | ) |

Resets cancellable to its uncancelled state.

If cancellable is currently in use by any cancellable operation then the behavior of this function is undefined.

Note that it is generally not a good idea to reuse an existing cancellable for more operations after it has been cancelled once, as this function might tempt you to do. The recommended practice is to drop the reference to a cancellable after cancelling it, and let it die with the outstanding async operations. You should create a fresh cancellable for further async operations.

## ◆ signal_cancelled()

Glib::SignalProxy< void > Gio::Cancellable::signal_cancelled | ( |  | ) |

Slot Prototype:
  void on_my_cancelled()

Flags: Run Last

Emitted when the operation has been cancelled.

Can be used by implementations of cancellable operations. If the operation is cancelled from another thread, the signal will be emitted in the thread that cancelled the operation, not the thread that is running the operation.

Note that disconnecting from this signal (or any signal) in a multi-threaded program is prone to race conditions. For instance it is possible that a signal handler may be invoked even after a call to Glib::signal_handler_disconnect() for that handler has already returned.

There is also a problem when cancellation happens right before connecting to the signal. If this happens the signal will unexpectedly not be emitted, and checking before connecting to the signal leaves a race condition where this is still happening.

In order to make it safe and easy to connect handlers there are two helper functions: g_cancellable_connect() and g_cancellable_disconnect() which protect against problems like this.

An example of how to us this:

[C example ellipted]

Note that the cancelled signal is emitted in the thread that the user cancelled from, which may be the main thread. So, the cancellable signal should not do something that can block.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::Cancellable > wrap | ( | GCancellable * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.